/*
 * Elena-Veronica Tecan, 335CA
 * Cub 64, proiect PM
 */

#include <avr/io.h>
#include <avr/interrupt.h>

#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>

#define F_CPU 16000000
#define DELAY_SECVENTA 500
#define REPETARE_SECVENTA 10
#define NR_SECVENTE 2

/* Secventele de aprindere a LED-urilor */
void secventa(int select) {

	/* Sting LED-urile pentru a pregati noua secventa. */
	PORTA = 0;
	PORTC = 0;
	PORTD = 0;

	int i;

	switch (select) {
		/* Secventa 0 */
		case 0:
			for (i = 0; i < REPETARE_SECVENTA; i++) {
				PORTA = 0xFF;
				PORTC = 0xFF;
				PORTD = 0b00010000;
				_delay_ms(DELAY_SECVENTA);

				PORTD = 0b00100000;
				_delay_ms(DELAY_SECVENTA);

				PORTD = 0b01000000;
				_delay_ms(DELAY_SECVENTA);

				PORTD = 0b10000000;
				_delay_ms(DELAY_SECVENTA);
			}

			break;

		/* Secventa 1 */
		case 1:
			for (i = 0; i < REPETARE_SECVENTA; i++) {
				PORTA = 0xFF;
				PORTC = 0xFF;
				PORTD = 0xF0;
				_delay_ms(DELAY_SECVENTA);

				PORTD = 0;
				_delay_ms(DELAY_SECVENTA);
			}

			break;
	}
}

int main(void) {

	/* Setez toti pinii porturilor A si C ca pini de iesire. */
	DDRA = 0xFF;
	DDRC = 0xFF;

	/* Folosesc ultimii 4 biti ai portului D pentru a controla nivelele */
	DDRD = 0x0F;

	/* Ciclez intre cele NR_SECVENTE secvente disponibile */	
	int select = 0;
	while (1) {
		secventa(select);
		select = (select + 1) % NR_SECVENTE;
	}

	return 0;
}
